classification
Title: startswith error message is incomplete
Type: behavior Stage:
Components: Interpreter Core Versions: Python 3.1, Python 3.2, Python 3.3, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: ezio.melotti Nosy List: eric.araujo, ezio.melotti, haypo, python-dev, r.david.murray, santoso.wijaya, srid
Priority: normal Keywords: needs review, patch

Created on 2009-08-24 21:33 by srid, last changed 2011-04-27 10:16 by ezio.melotti. This issue is now closed.

Files
File name Uploaded Description Edit
issue6780.diff ezio.melotti, 2010-03-14 07:18 patch for trunk
issue6780-2.diff ezio.melotti, 2011-04-24 01:57 Patch against 2.7 review
Messages (9)
msg91942 - (view) Author: Sridhar Ratnakumar (srid) Date: 2009-08-24 21:33
The `startswith` method accepts both string and tuple (not list). Yet 
the error message suggests that it expects (only) a character buffer 
object.

In Python-2.6:

>>> "foo".startswith(['fo', 'df'])
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: expected a character buffer object

In Python-3.x, the error message is different:

>>> "foo".startswith(["fo"])
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: Can't convert 'list' object to str implicitly

Aside: why not try to convert 'list' object to tuple?
msg91949 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2009-08-25 09:23
In the examples you used byte strings for Py2 and Unicode strings for
Py3. On Py3 the same example with byte strings gives an error similar to
the one raised by Py2:

>>> b"foo".startswith([b"fo"])
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: expected an object with the buffer interface
(vs. Py2's expected a character buffer object)

The error raised by Py2 with Unicode strings is more or less the same of
Py3 too:

>>> u"foo".startswith([u"fo", u"df"])
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: coercing to Unicode: need string or buffer, list found
(vs. Py3's Can't convert 'list' object to str implicitly)

If I understood correctly the C code in /Objects/unicodeobject.c, this
is because startswith checks if the 'prefix' is a tuple and, if not, it
assumes that is a Unicode string. The 'prefix' is then converted to
Unicode by PyUnicode_FromObject and if it's a list or some other object
the error "Can't convert 'list' object to str implicitly" / "coercing to
Unicode: need string or buffer, list found" is raised.

I agree that a more explicit error message would be better, something
like: "'prefix' must be a character buffer object or a tuple, not 'list'".

> Aside: why not try to convert 'list' object to tuple?

If the support for lists is added, it should probably be extended to all
the iterables, but strings are iterables too, so that will create some
problem. It could be checked if 'prefix' is a string and if not assume
that is an iterable of strings, but I don't know if it's worth doing it.
msg101042 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2010-03-14 07:18
Here is a proof of concept that solves the problem for unicode strings and startswith/endswith.
If during the conversion to Unicode a TypeError is raised (e.g. TypeError: Can't convert 'list' object to str implicitly), the error message is changed to "TypeError: startswith first arg must be str, unicode, or tuple, not list".
If the error is not a TypeError (e.g. a UnicodeDecodeError) the behavior is unchanged.
I haven't tested the patch thoroughly, but if this approach is OK I will prepare a complete patch.
msg123264 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2010-12-03 16:48
See also #10616.
msg124317 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2010-12-18 20:42
The approach looks good to me.  I think this issue is orthogonal to #10616, since the message here needs to be modified anyway, regardless of what happens to the underlying issue.
msg134321 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2011-04-24 01:57
Attached an updated patch for 2.7 with tests that check that UnicodeErrors are still raised and that the error message mentions 'str', 'unicode' and 'tuple'.
msg134442 - (view) Author: Roundup Robot (python-dev) Date: 2011-04-26 03:45
New changeset 3ceeccbc2c3b by Ezio Melotti in branch '2.7':
#6780: fix starts/endswith error message to mention that tuples are accepted too.
http://hg.python.org/cpython/rev/3ceeccbc2c3b

New changeset bcbf8c3c4a88 by Ezio Melotti in branch '3.1':
#6780: fix starts/endswith error message to mention that tuples are accepted too.
http://hg.python.org/cpython/rev/bcbf8c3c4a88

New changeset f393c507717a by Ezio Melotti in branch '3.2':
#6780: merge with 3.1.
http://hg.python.org/cpython/rev/f393c507717a

New changeset a1a1296556d7 by Ezio Melotti in branch 'default':
#6780: merge with 3.2.
http://hg.python.org/cpython/rev/a1a1296556d7
msg134546 - (view) Author: √Čric Araujo (eric.araujo) * (Python committer) Date: 2011-04-27 10:13
I would have used with self.assertRaises to write the tests, thinking it would be less verbose/cumbersome.
msg134547 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2011-04-27 10:16
In 3.1 I had to use try/except because cm.exception is new in 2.7/3.2.
I used assertRaises on the other branches.
History
Date User Action Args
2011-04-27 10:16:11ezio.melottisetmessages: + msg134547
2011-04-27 10:13:16eric.araujosetnosy: + eric.araujo
messages: + msg134546
2011-04-26 03:46:41ezio.melottisetstatus: open -> closed
resolution: fixed
stage: patch review ->
2011-04-26 03:45:18python-devsetnosy: + python-dev
messages: + msg134442
2011-04-25 02:58:53santoso.wijayasetnosy: + santoso.wijaya
2011-04-24 14:16:36ezio.melottisetkeywords: + needs review
stage: needs patch -> patch review
versions: + Python 3.3
2011-04-24 01:57:57ezio.melottisetfiles: + issue6780-2.diff

messages: + msg134321
2010-12-18 20:42:53r.david.murraysetnosy: haypo, ezio.melotti, r.david.murray, srid
versions: - Python 2.6
2010-12-18 20:42:27r.david.murraysetnosy: + r.david.murray
messages: + msg124317
2010-12-03 16:48:52hayposetnosy: + haypo
messages: + msg123264
2010-03-14 07:18:45ezio.melottisetkeywords: + patch
files: + issue6780.diff
messages: + msg101042
2010-02-27 09:54:16ezio.melottisetassignee: ezio.melotti
stage: needs patch
versions: + Python 2.7, Python 3.2
2009-08-25 09:23:30ezio.melottisetpriority: normal

nosy: + ezio.melotti
messages: + msg91949

components: + Interpreter Core, - Library (Lib)
2009-08-24 21:33:11sridcreate